/*             CSE 687 Project 2 --- String Class 

            Student Name: Gang Cheng SSN:223-61-3010               */

/*******************************************************************
 * proj2.cc ---- main program to test the member & frind functions *
 *               for class String and its derived class BCstring   *
 *******************************************************************/

#include <stdio.h>  // NULL
#include <fstream.h> 
#include "string.hh"  // class String

extern void error(char *);      // error 

/* function prototypes */
void compact_line(String& sline,BCstring& cline);
int function_line(BCstring& sline,const int i);

//--- <void error(char *s)> ---//
/* error handler */
void error(char *s)
{
  cerr << s; 
  exit(1);
}

//--- <main program> ---//
/* test the member and friend functions for class String
   and its derived class BCstring */
main(int argc, char *argv[])
{
  // check input file on command line
  if (argc < 2) error("Please enter file name on command line\n");

  ifstream fp(argv[1]);
 
  // check i/o status
  if (!fp) {
    cerr << "cannot open file: " << argv[1] << "\n";
    exit(1);
  };
  // status information     
  cout << "This is file " << argv[1]
    << "\nProcessed by " <<  argv[0] << "\n\n";

  String sline; // input line buffer.(To illustrate
                // the use of String class and BCstring class, we
                // use String here to store the original line)

  long lines = 0; // line counter
  while (fp) {
    fp >>sline; // read in a line
    lines++;

    int i = 0; char ch;

    // get ride of comment part of a line
    while ((ch = sline[i++])!= '/' && (ch != '\0'));
    if (ch = '/') sline[--i] = '\0';

    // find out if the line contains '(' (possible wanted line)
    i = 0;
    while ((ch = sline[i++])!= '(' && (ch != '\0'));
 
    if (ch == '(') {   // line containing '('

      BCstring cline;  // compacted line buffer.(To illustrate
                       // the use of String class and BCstring class, we
                       // use BCstring here to store the compacted line)

      compact_line(sline,cline); // get ride of blank space,
                                 // compacted line is in cline 
      // relocate '(' in the compacted line and test if the line
      // contains function declaration, definition, invocation etc.
      i = 0;
      char lines_string[15];
      do {
	while ( (ch = cline[i]) != '(' && (ch != '\0')) i++;
	if ((ch == '(') && function_line(cline,i)) { // find wanted line
	  sprintf(lines_string,"Line %5d: ",lines);
	  // print out the line
	  //cout <<(String&)lines_string + sline << "\n"; 
	  // or cout <<(String&)lines_string + sline + (String&)"\n"
	  break;
	};
	i++;
      } while (ch != '\0');
    };
  };
      
  exit(0); 
}

//---<void compact_line(BCstring& sline,BCstring& cline)>---//
/* get ride of blank space in a line */
void compact_line(String& sline,BCstring& cline) // get ride of blank space 
{
  int i = 0, j = 0;
  char ch;
  cline = sline;  // copy a line

  while ((ch = sline[i++]) != '\0')  // skip blank space
    if (ch != ' ' && ch != '\t') cline[j++] = ch; // copy non-blank char.

  cline[j] = '\0';  // string terminal symbol

  return;
}

//---<int function_line(BCstring& sline, const int n)>---//
/* test if a line contains function declaration, definition, invocation etc. */
int function_line(BCstring& sline, const int n)
{
  // macro difinitions for test different '(' 
  // occurrences in expressions and statments
#define char_keyword(c) (c=='*'||c=='('||c==')'||c=='['|| c==']'||c==':'||c=='&'||\
	       	    c=='|'||c=='~'||c=='"'||c=='\''|| c=='!'||c=='%'||c=='>'||\
                    c=='<'||c=='+'||c=='-'||c=='/'|| c=='?'|| c=='='|| c==';') 

#define keyword(x) ((x) == "  case" || (x) == "    do" || (x) == "  else" ||\
                      (x) == "   for" || (x) == "  goto" || (x) == "    if" ||\
                      (x) == "return" || (x) == "sizeof" || (x) == "switch" ||\
                      (x) == " while" )
  #define true 1
  #define false 0  

  // first exclude possible occurring of '(' in an expression 
  // n is the location of '(' in a string
  if (n == 0 || ((n >0) && char_keyword(sline[n-1]))) return false;

  // exlude statements
  BCstring temp(6); // longest keyword such as "switch"
  int i, j;

  temp[6] = '\0'; 
  // exclude possible occurring of '(' in a statement
  for (i = 5, j = n - 1; i>=0; i--, j--) {     
     if (j>=0) temp[i] = sline[j];
     else temp[i] = ' ';
     if (keyword(temp)) return false; // assuming unfilled positions in
                                      // BCstring temp is ' '
  };

  return true;
}

